using System;
using System.IO;
using iTextSharp.license;
using iTextSharp.text.pdf;
using iTextSharp.tool.xml.xtra.xfa;
using iTextSharp.text;

namespace FillAndFlatten
{
    class Program
    {

        public void ManipulatePdf(String src, String xml, String dest) 
        {
            Console.Out.WriteLine("Manipulating the form");
        	
            
    	    MemoryStream ms = new MemoryStream();
        	
            PdfReader reader = new PdfReader(src);
            PdfStamper stamper = new PdfStamper(reader, ms);
            stamper.Writer.CloseStream = false;
            AcroFields form = stamper.AcroFields;
            XfaForm xfa = form.Xfa;
            xfa.FillXfaForm(new FileStream(xml, FileMode.Open));
            stamper.Close();

            Console.Out.WriteLine("The form is filled");

            Document document = new Document();
            PdfWriter writer = PdfWriter.GetInstance(document, new FileStream(dest, FileMode.Create));
            XFAFlattener xfaf = new XFAFlattener(document, writer);
            ms.Position = 0;
            xfaf.Flatten(new PdfReader(ms));
            document.Close();
            
            Console.Out.WriteLine("The form is flattened");
        }

        static int Main(string[] args)
        {
            LicenseKey.LoadLicenseFile("../../Resources/itextkey.xml");
            Program app = new Program();
            app.ManipulatePdf("../../Resources/xfa_form.pdf", "../../Resources/xfa_data.xml", "xfa_flattened.pdf");
            return 0;
        }
    }
}
